Read("polynames.gap");


redo := true;
#redo := false;

#AllCompositions := function(ap) 
#  local gp,sz,all,new,nex,i,j;
#  gp := List(ap,x -> [Size(Group(x)),x]);
#  sz := Set(gp,x -> x[1]);
#  sz := Union(sz,[4]);
#  all := List(gp);
#  new := List(gp);
#  while Size(new) > 0 do
#    nex := [];
#    for i in new do
#      for j in gp do
#        Append(nex,[[i[1]*j[1],Composition(i[2],j[2])]]);
#      od;
#    od;
#    nex := Filtered(nex,x -> x[1] in sz);
#    Append(all,nex);
#    new := nex;
#  od;
#  return List(all,x -> x[2]);
#end;

AllCompositions := function(app)
  local sz,gp,all,new,nex,i,j;
  gp := List(app);
  sz := Set(app,x -> x[1][1]);
  sz := Union(sz,[4]);
  all := List(app);
  new := List(app);
  while Size(new) > 0 do
    nex := [];
    for i in new do
      for j in gp do
        if i[1][1]*j[1][1] in sz then
          Append(nex,[[[i[1][1]*j[1][1],0,0],Composition(i[2],j[2])]]);
        fi;
      od;
    od;
    Append(all,nex);
    new := nex;
  od;
  return all;
end;

AllDegenerates := x -> Filtered(AllCompositions(x),y -> 2 in PolytopeType(y[2]));

ListDec := function(head,delim,tail,pt) 
  local str,i;
  str := head;
  for i in [1..Length(pt)] do
    if (i > 1) then Append(str,delim); fi;
    Append(str,DigitsNumber(pt[i],10));
  od;
  Append(str,tail);
  return str;
end;

PolyTypeDec := function(pt)
  return ListDec("{",",","}",pt);
end;
# todo : 
#  make a URL function.  (relative, using depth as a parameter)
#  add hyperlinks
#  add index.html files. 

if not redo then 
  Print("reading app and appd from file\n");
  Read("app.gap");
fi;
if redo then
  Print("reading ap from file\n");
  Read("protodata.gap");
  Print("calculating app and appd\n");
  app := List(ap,x -> [Size(Group(x)),List(PolytopeType(x), i -> i),IdGroup(Group(x)),x]);;
  Sort(app);
  app := List(app,x -> [List(x[3]),x[4]]);;
  gid := Set(app,x -> x[1]);;
  gidm := List(gid,x -> [x,Size(Filtered(app,y -> y[1] = x))]);;
  gidc := List(gid,x -> [x,1]);;
  for p in app do
    gg := Filtered(gidc,x -> x[1][1] = p[1][1] and x[1][2] = p[1][2])[1];;
    Append(p[1],[gg[2]]);;
    gg[2] := gg[2]+1;;
  od;
  Print("calculating apd\n");
  apd := AllDegenerates(app);;
  appd := List(apd,x -> [x[1][1],List(PolytopeType(x[2]), i -> i),IdGroup(Group(x[2])),x[2]]);;
  Sort(appd);;
  appd := List(appd,x -> [List(x[3]),x[4]]);;
  gidd := Set(appd,x -> x[1]);;
  gidmd := List(gidd,x -> [x,Size(Filtered(app,y -> y[1] = x))]);;
  gidcd := List(gidd,x -> [x,1]);;
  p := 0;;
  for p in appd do
    gg := Filtered(gidcd,x -> x[1][1] = p[1][1] and x[1][2] = p[1][2])[1];;
    Append(p[1],[gg[2]]);;
    gg[2] := gg[2]+1;;
  od;
  app := List(app,x -> [[x[1][1],x[1][2],x[1][3],0],x[2]]);;
  Append(app,List(appd,x -> [[x[1][1],x[1][2],x[1][3],1],x[2]]));;
  PrintTo("app.gap","app := ",app,";;\n");;
#  AppendTo("app.gap","appd := ",appd,";;\n");
fi;

Print("calculating poly and polyd\n");

poly := List(app);;
#app := List(app,x -> [[x[1][1],x[1][2]],x[2]]);
gid := Set(app,x -> [x[1][1],x[1][2]]);
gsz := Set(gid,x -> x[1]);

#polyd := List(appd);
#appd := List(appd,x -> [[x[1][1],x[1][2]],x[2]]);
#gidd := Set(appd,x -> x[1]);
#gszd := Set(gidd,x -> x[1]);

HomeURL := function(depth)
  local tmp;
  if depth <= 0 then 
    tmp := "atlas/";
    return tmp;
  fi;
  if depth > 0 then 
    tmp := Concatenation("../",HomeURL(depth-1));
    return tmp;
  fi;
end; 


PolyID := function(pp)
  local grpid,pol;
  if  IsList(pp[1]) then return List(pp[1]); fi;
  grpid := IdGroup(Group(pp));
#  if IsDegenerate(pp) then
#    pol := Filtered(polyd,x -> x[1][1]=grpid[1] and x[1][2] = grpid[2]);
#  else    
    pol := Filtered(poly,x -> x[1][1]=grpid[1] and x[1][2] = grpid[2]);
#  fi;
  pol := Filtered(pol,x -> PolytopeType(x[2]) = PolytopeType(pp));
  pol := Filtered(pol,x -> IsIsom(x[2],pp));
  if Size(pol) = 0 then return []; fi;
  if Size(pol) > 1 then Print("Error in PolyID!! More than one returned!!"); fi;
  return pol[1][1];
end;

Covers := function(p,q) 
  local pt,qt,rt;
  if not Size(p[2])=Size(q[2]) then return false; fi;
  if p[1][1] = q[1][1] then return false; fi;
  if not IsInt(p[1][1]/q[1][1]) then return false; fi;
  pt := PolytopeType(p[2]);
  qt := PolytopeType(q[2]);
  rt := List([1..Length(pt)],i -> pt[i]/qt[i]);
  if not ForAll(rt,IsInt) then return false; fi;
  pt := Order(Product(p[2]));
  qt := Order(Product(q[2]));
  if not IsInt(pt/qt) then return false; fi;
  rt := GroupHomomorphismByImages(Group(p[2]),Group(q[2]),p[2],q[2]);
  if rt = fail then return false; fi;
  return true;
end;

getPolyByID := function(pid) 
  local pol;
  pol := Filtered(poly,x -> x[1]=pid);
  if Size(pol) = 0 then
    return fail;
  fi;
  if Size(pol) > 1 then
    Print("Warning! More than one poly found for pid=",pid,"\n");
  fi;
  return pol[1];
end;



if redo then
#  apptmp := List(app,x -> [[x[1][1],x[1][2],x[1][3],0],x[2]));
#  Append(apptmp,List(appd,x -> [[x[1][1],x[1][2],x[1][3],0],x[2]));

  iii := 0;
  Print("Calculating Duals\n");
  duals := [];
  for p in app do
    if not p[1] in List(duals,x -> x[1])  then
      d := PolyID(Dual(p[2])); 
      Append(duals,[[p[1],d]]);
      if not d=p[1] then
        Append(duals,[[d,p[1]]]);
      fi;
    fi;
    iii := iii+1;
    if iii mod 50 = 0 then
      Print(iii," of ",Size(app)," done.\n");
    fi;
  od;

  iii := 0;
  Print("Calculating Petrials\n");
  petrials := [];
  for p in app do
    if Size(p[2])=3 then
      if not p[1] in List(petrials,x -> x[1]) then
        d := Petrial(p[2]);
        if not d=fail then
          d := PolyID(d);  
          Append(petrials,[[p[1],d]]);          
          if not d=p[1] then
            Append(petrials,[[d,p[1]]]);
          fi;
        fi;
      fi;
    fi;
    iii := iii+1;
    if iii mod 50 = 0 then
      Print(iii," of ",Size(app)," done. ",Size(petrials)," petrials.\n");
    fi;
  od;

  iii := 0;
  Print("Calculating Facets and VFs\n");
  facets := [];
  vfs := [];
  for p in app do
    if Size(p[2])>1 then
      d := Facet(p[2]);
      d := PolyID(d);  
      Append(facets,[[p[1],d]]);          
      pp := Filtered(duals, x -> x[1] = p[1] or x[1] = d);
      dd := Filtered(pp, x -> x[1] = d);
      pp := Filtered(pp, x -> x[1] = p[1]);
      Append(vfs,[[pp[1][2],dd[1][2]]]);
    fi;
    iii := iii+1;
    if iii mod 50 = 0 then
      Print(iii," of ",Size(app)," done. \n");
    fi;
  od;

 Print("Calculating quotients\n");

 covers := [];

 apsz := Set(app,x -> Size(x[2]));
 apsz := List(apsz,x -> Filtered(app,y -> Size(y[2])=x));
 for i in [1..Length(app)] do
   p := app[i];
if i mod 50 = 0 then
   Print("Now checking ",i," of ",Length(app),", ",p[1]," of type ",PolytopeType(p[2]),"\n");
fi;
   aptmp := apsz[Size(p[2])];
   for j in [1..Length(aptmp)] do
     q := aptmp[j];
     if Covers(p,q) then
       Append(covers,[[p[1],q[1]]]);
if Size(covers) mod 100 = 0 then 
       Print("found ",Size(covers)," so far\n");
 fi;
     fi;
   od;
od;
 
  iii := 0;
  Print("Finding Maximal Quotients\n");
  maxcovers := [];
  for c in covers do
    c1 := Set(Filtered(covers,x -> x[1]=c[1]),y -> y[2]);
    c2 := Set(Filtered(covers,x -> x[2]=c[2]),y -> y[1]);
    if Size(Intersection(c1,c2)) = 0 then
       Append(maxcovers,[c]);
#       Print(c," is maximal: ",PolytopeType(getPolyByID(c[1])[2]),"-->",PolytopeType(getPolyByID(c[2])[2]),"\n");
    fi;
    iii := iii+1;
    if iii mod 100 = 0 then
      Print(iii," of ",Size(covers)," done. Found ",Size(maxcovers)," maximal quotients\n");
    fi;
  od;

    

  Print("Calculating universal polytopes\n");
  universals := [];
  iii := 0;
  for p in app do
    if p[1][4]=1 then
      Append(universals,[List(p[1])]);
    else
      if IsConfirmedUniversal(p[2]) then
         Append(universals,[List(p[1])]);
      fi;      
    fi;
    iii := iii+1;
    if iii mod 50 = 0 then
      Print(iii," of ",Size(app)," done. ",Size(universals)," universals.\n");
    fi;
  od;

  AppendTo("app.gap","duals := ",duals,";;\n");
  AppendTo("app.gap","petrials := ",petrials,";;\n");
  AppendTo("app.gap","facets := ",facets,";;\n");
  AppendTo("app.gap","vfs := ",vfs,";;\n");
  AppendTo("app.gap","covers := ",covers,";;\n");
  AppendTo("app.gap","maxcovers := ",maxcovers,";;\n");
  AppendTo("app.gap","universals := ",universals,";;\n");


         
fi;


PolyURL := function(pp,depth)
  local pid,tmp,degen;
  if depth > 1 then 
    tmp := Concatenation("../",PolyURL(pp,depth-1));
    return tmp;
  fi;
  pid := PolyID(pp);
  if (pid = []) then
    return HomeURL(depth);
  fi;
  if IsList(pp[1]) then
#    degen := IsDegenerate(pp[2]);
    degen := pp[1][4]=1;
  else
    degen := IsDegenerate(pp);
  fi;
  if depth = 0 then 
    tmp := Concatenation("atlas/");
    tmp := Concatenation(tmp,DigitsNumber(pid[1],10),"/");
    tmp := Concatenation(tmp,DigitsNumber(pid[2],10),"/");
    if degen then
      tmp := Concatenation(tmp,"d");
    fi;
    tmp := Concatenation(tmp,DigitsNumber(pid[3],10),".html");
    return tmp;
  fi;
  if depth = 1 then 
    tmp := DigitsNumber(pid[1],10);
    tmp := Concatenation(tmp,"/",DigitsNumber(pid[2],10));
    tmp := Concatenation(tmp,"/");
    if degen then
      tmp := Concatenation(tmp,"d");
    fi;
    tmp := Concatenation(tmp,DigitsNumber(pid[3],10),".html");
    return tmp;
  fi;
#  if depth = 3 then 
#    tmp := Concatenation("../../",DigitsNumber(pid[1],10));
#    tmp := Concatenation(tmp,"/",DigitsNumber(pid[2],10));
#    tmp := Concatenation(tmp,"/",DigitsNumber(pid[3],10),".html");
#    return tmp;
#  fi;
end; 



#FacetOf := function(pp) 
#  local pid,pol;
#  pid := PolyID(pp);
#  pol := Filtered(poly,x -> x[1][1]>pid[1] and x[1][1] mod pid[1] = 0);
#  pol := Filtered(pol,x -> Size(x[2]) = Size(pp)+1);
#  pol := Filtered(pol,x -> IsIsom(pp,Facet(x[2])));
#  return pol;
#end;

IsUniv := function(pid) 
  return pid in universals;
end;

FacetsOf := function(pp)
  local pid,pol;
  pid := PolyID(pp);
  pol := Filtered(facets,x -> x[2] = pid);
  pol := List(pol,x -> getPolyByID(x[1]));
  return pol;
end;

VFsOf := function(pp) 
  local pid,pol;
  pid := PolyID(pp);
  pol := Filtered(vfs,x -> x[2] = pid);
  pol := List(pol,x -> getPolyByID(x[1]));
  return pol;
end;

FacetOf := function(pp)
  local pid,pol;
  pid := PolyID(pp);
  pol := Filtered(facets,x -> x[1] = pid);
  pol := List(pol,x -> getPolyByID(x[2]));
  if Size(pol)=0 then
    return fail;
  fi;
  if Size(pol) > 1 then
    Print("Warning! more than one facet found. pp = ",pp,"\n");
  fi;
  return pol[1];
end;

VFOf := function(pp) 
  local pid,pol;
  pid := PolyID(pp);
  pol := Filtered(vfs,x -> x[1] = pid);
  pol := List(pol,x -> getPolyByID(x[2]));
  if Size(pol)=0 then
    return fail;
  fi;
  if Size(pol) > 1 then
    Print("Warning! more than one vf found. pp = ",pp,"\n");
  fi;
  return pol[1];
end;

DualOf := function(pp)
  local pid,pol;
  pid := PolyID(pp);
  pol := Filtered(duals,x -> x[1] = pid);
  pol := List(pol,x -> getPolyByID(x[2]));
  if Size(pol)=0 then
    Print("Warning! no dual found. pp = ",pp,"\n");
    return fail;
  fi;
  if Size(pol) > 1 then
    Print("Warning! more than one dual found. pp = ",pp,"\n");
  fi;
  return pol[1];
end;

mailTo := function(name,refstr) 
  AppendTo(name,"<script>\ndocument.write(\"<a href=\\\"mailto:\");\n");
  AppendTo(name,"document.write(\"Michael.Hartley\");");
  AppendTo(name,"document.write(\"@\");");
  AppendTo(name,"document.write(\"nottingham.edu.my\");");
  AppendTo(name,"document.write(\"\\\">",refstr,"</a>\\n\");\n</script>");
end;


PetrialOf := function(pp)
  local pid,pol;
  pid := PolyID(pp);
  pol := Filtered(petrials,x -> x[1] = pid);
  pol := List(pol,x -> getPolyByID(x[2]));
  if Size(pol)=0 then
    return fail;
  fi;
  if Size(pol) > 1 then
    Print("Warning! more than one petrial found. pp = ",pp,"\n");
  fi;
  return pol[1];
end;

  
SummarisePoly := function(name, ppq, grp) 
  local f,ff,pt,k,rr,tmp,i,j,mx,pid,pnames,pp,qu,q,qufold,qfl,sep;
  pp := ppq[2];
  PrintTo(name,"<html><head><title>Polytope of Type ",PolyTypeDec(PolytopeType(pp))," with group ");
  AppendTo(name, ListDec("SmallGroup(",",",")",grp), " - Atlas of Small Regular Polytopes</title></head>\n");
  AppendTo(name, "<body bgcolor=#aaffcc>\n");
  AppendTo(name, "<h1>Polytope of Type ",PolyTypeDec(PolytopeType(pp)),"</h1>\n");
  AppendTo(name, "This page is part of the <a href=\"../../index.html\">");
  AppendTo(name, "Atlas of Small Regular Polytopes</a><br>");

  pid := PolyID(ppq);
#  if not IsDegenerate(pp) then
    pnames := getNames(pid[1],pid[2],pid[3],pid[4]);
    if Size(pnames) > 0 then
      AppendTo(name,"<b>Also Known As : </b>");
      for i in [1..Length(pnames)] do
        if (i>1) then 
          AppendTo(name,", ");
        fi;
        AppendTo(name,pnames[i]);
      od;
      AppendTo(name,".&nbsp;");
      mailTo(name,"Tell me");
      AppendTo(name,"if this polytope has another name.");
    else 
      mailTo(name,"Tell me");
      AppendTo(name,"if this polytope has a name.");
    fi;
   AppendTo(name,"<br>\n");
#  fi;
  AppendTo(name, "<b>Group : </b><a href=\"index.html\">", ListDec("SmallGroup(",",",")",grp),"</a><br>\n");
  AppendTo(name, "<b>Rank : </b><a href=\"../../r",Size(pp),"/index.html\">", Size(pp),"</a><br>\n");
  AppendTo(name, "<b>Schlafli Type : </b><a href=\"../../r",Size(pp),"/");
  AppendTo(name, ListDec("sch",".",".html\">",PolytopeType(pp)), PolyTypeDec(PolytopeType(pp)),"</a><br>\n");
  AppendTo(name, "<b>Number of vertices, edges, etc : </b>",ListDec("",", ","",fVec(pp)),"<br>\n");
  if Size(pp) > 1 then
    AppendTo(name, "<b>Order of ");
    rr := ();
    for i in [0..Length(pp)-1] do
      AppendTo(name, "s<sub><font size=-1>",i,"</font></sub>");
      rr := rr * pp[i+1];
    od;
    AppendTo(name," : </b>",Order(rr),"<br>\n");
  fi;
  if Size(pp) > 2 then
    AppendTo(name, "<b>Order of ");
    rr := ();
    for i in [0..Length(pp)-1] do
      AppendTo(name, "s<sub><font size=-1>",i,"</font></sub>");
      rr := rr * pp[i+1];
    od;
    for i in Reversed([1..Length(pp)-2]) do
      AppendTo(name, "s<sub><font size=-1>",i,"</font></sub>");
      rr := rr * pp[i+1];
    od;
    AppendTo(name," : </b>",Order(rr),"<br>\n");
  fi;
  AppendTo(name, "<b>Special Properties : </b><br>\n");
  if pid[4]=1 then
    AppendTo(name, "&nbsp;&nbsp;&nbsp;Degenerate<br>\n");
  fi;
  if IsUniv(pid) then
    AppendTo(name, "&nbsp;&nbsp;&nbsp;Universal<br>\n");
  fi;
  if IsSpherical(pp) then
    AppendTo(name, "&nbsp;&nbsp;&nbsp;Spherical<br>\n");
  fi;
  if IsProjective(pp) then
    AppendTo(name, "&nbsp;&nbsp;&nbsp;Projective<br>\n");
  fi;
  if IsToroidal(pp) then
    AppendTo(name, "&nbsp;&nbsp;&nbsp;Toroidal<br>\n");
  fi;
  if IsHyperbolicQuotient(pp) then
    AppendTo(name, "&nbsp;&nbsp;&nbsp;");
    if IsCompactHyperbolicQuotient(pp) then
      AppendTo(name, "Compact ");
    fi;
    AppendTo(name, "Hyperbolic Quotient<br>\n");
  fi;
  if IsLocallySpherical(pp) then
    AppendTo(name, "&nbsp;&nbsp;&nbsp;Locally Spherical<br>\n");
  fi;
  if IsLocallyToroidal(pp) then
    AppendTo(name, "&nbsp;&nbsp;&nbsp;Locally Toroidal<br>\n");
  fi;
  if IsLocallyProjective(pp) then
    AppendTo(name, "&nbsp;&nbsp;&nbsp;Locally Projective<br>\n");
  fi;
  if IsOrientable(pp) then
    AppendTo(name, "&nbsp;&nbsp;&nbsp;Orientable<br>\n");
  fi;
  if not IsOrientable(pp) then
    AppendTo(name, "&nbsp;&nbsp;&nbsp;Non-Orientable<br>\n");
  fi;
  if IsFlat(pp) then
    AppendTo(name, "&nbsp;&nbsp;&nbsp;Flat<br>\n");
  fi;
  if DualOf(ppq)[1]=pid then 
    AppendTo(name, "&nbsp;&nbsp;&nbsp;Self-Dual<br>\n");
  fi;
  pt := PetrialOf(ppq);
  if not pt = fail then
    if pt[1] = pid then
      AppendTo(name, "&nbsp;&nbsp;&nbsp;Self-Petrie<br>\n");
    fi;
  fi;
  AppendTo(name,"<b>Related Polytopes : </b><br>\n");
  if Size(pp)>1 then
    AppendTo(name,"&nbsp;&nbsp;&nbsp;<a href=\"",PolyURL(FacetOf(ppq),3),"\">Facet</a><br>\n");
    AppendTo(name,"&nbsp;&nbsp;&nbsp;<a href=\"",PolyURL(VFOf(ppq),3),"\">Vertex Figure</a><br>\n");
  fi;
  AppendTo(name,"&nbsp;&nbsp;&nbsp;<a href=\"",PolyURL(DualOf(ppq),3),"\">Dual</a><br>\n");
  if (Size(pp) = 3) then
    pt := PetrialOf(ppq);
    if not pt = fail then 
      AppendTo(name,"&nbsp;&nbsp;&nbsp;<a href=\"",PolyURL(pt,3),"\">Petrial</a><br>\n");
    fi;  
    pt := Halving(pp);
    if not pt = fail then 
      AppendTo(name,"&nbsp;&nbsp;&nbsp;<a href=\"",PolyURL(pt,3),"\">Halving Operation</a><br>\n");
    fi;  
    pt := Skewing(pp);
    if not pt = fail then 
#      if not 2 in PolytopeType(pt) then
        AppendTo(name,"&nbsp;&nbsp;&nbsp;<a href=\"",PolyURL(pt,3),"\">Skewing Operation</a><br>\n");
#      fi;
#      if 2 in PolytopeType(pt) then
#        AppendTo(name,"&nbsp;&nbsp;&nbsp;Skewing Operation");
#        AppendTo(name," : Type ",PolyTypeDec(PolytopeType(pt)),"<br>\n");
#      fi;
    fi; 
#    for k in [2..QuoInt(Order(pp[2]*pp[3])+1,2)-1] do
#      pt := Facetting(pp,k);
#      if not pt = fail then 
##        if not 2 in PolytopeType(pt) then
#          AppendTo(name,"&nbsp;&nbsp;&nbsp;<a href=\"",PolyURL(pt,3),"\">Facetting Operation</a>");
#          AppendTo(name," (k = ",k,")<br>\n");
##        fi;
##        if 2 in PolytopeType(pt) then
##          AppendTo(name,"&nbsp;&nbsp;&nbsp;Facetting Operation");
##          AppendTo(name," (k = ",k,") : Type ",PolyTypeDec(PolytopeType(pt)),"<br>\n");
##        fi;
#      fi; 
#    od;
  fi;
  AppendTo(name,"<b>Facet Of :</b><br>\n");
  ff := FacetsOf(ppq);
  if (Size(ff) = 0) then       
    AppendTo(name,"&nbsp;&nbsp;&nbsp;None in this Atlas<br>\n");
  fi;
  for f in ff do 
    AppendTo(name,"&nbsp;&nbsp;&nbsp;");
#Print("A");
    AppendTo(name,"<a href=\"",PolyURL(f,3),"\">");
#Print("B");
    AppendTo(name,PolyTypeDec(PolytopeType(f[2])),"</a> ");
#Print("C");
    AppendTo(name,"of size ",f[1][1],"<br>\n");
#Print("D");
  od;
#Print("E");
  AppendTo(name,"<b>Vertex Figure Of :</b><br>\n");
  ff := VFsOf(ppq);
  if (Size(ff) = 0) then       
    AppendTo(name,"&nbsp;&nbsp;&nbsp;None in this Atlas<br>\n");
  fi;
  for f in ff do 
    AppendTo(name,"&nbsp;&nbsp;&nbsp;");
    AppendTo(name,"<a href=\"",PolyURL(f,3),"\">",PolyTypeDec(PolytopeType(f[2])),"</a> ");
    AppendTo(name,"of size ",f[1][1],"<br>\n");
  od;
  AppendTo(name,"<b>Quotients</b> (Maximal Quotients in <b>Boldface</b>) :<br>\n");
  qu := List(Filtered(covers,x -> x[1] = pid),y -> getPolyByID(y[2]));
  qufold := Set(qu,x -> pid[1]/x[1][1]);
  if (Size(qu)=0) then
     AppendTo(name,"&nbsp;&nbsp;&nbsp;No Regular Quotients.<br>\n");
  fi;
  for qfl in qufold do
   AppendTo(name,"&nbsp;&nbsp;&nbsp;",qfl,"-fold quotients");
   sep := " : ";
   for q in Filtered(qu,x -> pid[1]/x[1][1] = qfl) do
    AppendTo(name,sep);
    if [pid,q[1]] in maxcovers then
       AppendTo(name,"<b>");
    fi;
    AppendTo(name,"<a href=\"",PolyURL(q,3),"\">");
    AppendTo(name,PolyTypeDec(PolytopeType(q[2])),"</a>");
    if [pid,q[1]] in maxcovers then
       AppendTo(name,"</b>");
    fi;
    sep := ", ";
   od;
   AppendTo(name,"<br>\n");
  od;
  AppendTo(name,"<b>Covers</b> (Minimal Covers in <b>Boldface</b>) :<br>\n");
  qu := List(Filtered(covers,x -> x[2] = pid),y -> getPolyByID(y[1]));
  qufold := Set(qu,x -> x[1][1]/pid[1]);
  if (Size(qu)=0) then
     AppendTo(name,"&nbsp;&nbsp;&nbsp;None in this atlas.<br>\n");
  fi;
  for qfl in qufold do
   AppendTo(name,"&nbsp;&nbsp;&nbsp;",qfl,"-fold covers");
   sep := " : ";
   for q in Filtered(qu,x -> x[1][1]/pid[1] = qfl) do
    AppendTo(name,sep);
    if [q[1],pid] in maxcovers then
       AppendTo(name,"<b>");
    fi;
    AppendTo(name,"<a href=\"",PolyURL(q,3),"\">");
    AppendTo(name,PolyTypeDec(PolytopeType(q[2])),"</a>");
    if [q[1],pid] in maxcovers then
       AppendTo(name,"</b>");
    fi;
    sep := ", ";
   od;
   AppendTo(name,"<br>\n");
  od;
  AppendTo(name,"<b>Permutation Representation (GAP) : </b><br>\n<pre>\n");
  for i in [1..Length(pp)] do
    AppendTo(name,"s",i-1," := ",pp[i],";;\n");
  od;
  AppendTo(name,"poly := Group([");
  for i in [1..Length(pp)] do
    if (i > 1) then AppendTo(name,","); fi;
    AppendTo(name,"s",i-1);
  od;
  AppendTo(name,"]);;\n \n");
  AppendTo(name,"</pre>\n");
  AppendTo(name,"<b>Finitely Presented Group Representation (GAP) : </b><br>\n<pre>\n");
  tmp := Group(pp);
  tmp := PresentationViaCosetTable(tmp);
  tmp := FpGroupPresentation(tmp);
  tmp := RelatorsOfFpGroup(tmp);
  tmp := List(tmp, LetterRepAssocWord);
  AppendTo(name,"F := FreeGroup("); 
  for i in [1..Length(pp)] do
    if (i > 1) then AppendTo(name,","); fi;
    AppendTo(name,"\"s",i-1,"\"");
  od;
  AppendTo(name,");;\n");
  for i in [1..Length(pp)] do
    AppendTo(name,"s",i-1," := F.",i,";;  ");
  od;
  AppendTo(name,"\n");
  AppendTo(name,"rels := [ ");
  k := 0;
  for i in [1..Length(tmp)] do
    if (i > 1) then AppendTo(name,", "); fi;
    if k > 10 then AppendTo(name,"\n"); k := 0; fi;
    for j in [1..Length(tmp[i])] do
      if (j > 1) then AppendTo(name,"*"); fi;
      k := k+1;
      AppendTo(name,"s",tmp[i][j]-1);
    od;
  od;
  AppendTo(name," ];;\n");
  AppendTo(name,"poly := F / rels;;\n \n");
  AppendTo(name,"</pre>\n");
  AppendTo(name,"<b>Permutation Representation (Magma) : </b><br>\n<pre>\n");
  mx := Maximum(MovedPoints(Group(pp)));
  for i in [1..Length(pp)] do
    AppendTo(name,"s",i-1," := Sym(",mx,")!",pp[i],";\n");
  od;
  AppendTo(name,"poly := sub&lt;Sym(",mx,")|");
  for i in [1..Length(pp)] do
    if (i > 1) then AppendTo(name,","); fi;
    AppendTo(name,"s",i-1);
  od;
  AppendTo(name,"&gt;;\n \n");
  AppendTo(name,"</pre>\n");
  AppendTo(name,"<b>Finitely Presented Group Representation (Magma) : </b><br>\n<pre>\n");
  AppendTo(name,"poly&lt;");
  for i in [1..Length(pp)] do
    if (i > 1) then AppendTo(name,","); fi;
    AppendTo(name,"s",i-1);
  od;
  AppendTo(name,"&gt; := Group&lt; ");
  for i in [1..Length(pp)] do
    if (i > 1) then AppendTo(name,","); fi;
    AppendTo(name,"s",i-1);
  od;
  AppendTo(name," | ");
  k := 5;
  for i in [1..Length(tmp)] do
    if (i > 1) then AppendTo(name,", "); fi;
    if k > 10 then AppendTo(name,"\n"); k := 0; fi;
    for j in [1..Length(tmp[i])] do
      if (j > 1) then AppendTo(name,"*"); fi;
      k := k+1;
      AppendTo(name,"s",tmp[i][j]-1);
    od;
  od;
  AppendTo(name," >; \n \n");
  AppendTo(name,"</pre>\n");
  if not IsDegenerate(pp) then
    pid := PolyID(ppq);
    pnames := getCitations(pid[1],pid[2],pid[3],pid[4]);
    AppendTo(name,"<b>References : </b>");
    if Size(pnames) > 0 then
      AppendTo(name,"<ol>");
      for i in [1..Length(pnames)] do
        AppendTo(name,"<li> ",pnames[i],"\n");
      od;
      AppendTo(name,"</ol>\n");
    else AppendTo(name,"None. "); fi;
  fi;
  AppendTo(name,"<br>");
  mailTo(name,"Suggest a published reference");
  AppendTo(name," to this polytope<br>");
  AppendTo(name,"</body></html>\n");
end;

SummariseGroup := function(name,grp)
  local pol,j,num,f,ff,ffd;
  PrintTo(name,"<html><head><title>Polytopes for Group ");
  AppendTo(name, ListDec("SmallGroup(",",",")",grp), " - Atlas of Small Regular Polytopes</title></head>\n");
  AppendTo(name, "<body bgcolor=#aaffcc>\n");
  AppendTo(name, "<h1>Polytopes for Group ");
  AppendTo(name, ListDec("SmallGroup(",",",")",grp),"</h1>\n");
  AppendTo(name, "This page is part of the <a href=\"../../index.html\">");
  AppendTo(name, "Atlas of Small Regular Polytopes</a><br>");
  AppendTo(name,"<b>Nondegenerate Polytopes : </b>");
  ff := Filtered(poly,x -> x[1][1]=grp[1] and x[1][2] = grp[2] and x[1][4]=0);
#  ff := List(ff,x -> x[2]); 
  if Size(ff) = 0 then
    AppendTo(name,"None.\n<br><br>\n");
  else
    AppendTo(name,"<ol>\n");
    for f in ff do 
      AppendTo(name,"<li><a href=\"",PolyURL(f,3),"\">",PolyTypeDec(PolytopeType(f[2])),"</a> ");
      AppendTo(name,"<br>\n");
    od;
    AppendTo(name,"</ol><br><br>\n");
  fi;
  AppendTo(name, "<b>Degenerate Polytopes : </b>\n");
  ffd := Filtered(poly,x -> x[1][1]=grp[1] and x[1][2] = grp[2] and x[1][4]=1);
#  ffd := List(ffd,x -> x[2]); 
  if Size(ffd) = 0 then
    AppendTo(name,"None.\n<br><br>\n");
  else
    AppendTo(name,"<ol>\n");
    for f in ffd do 
      AppendTo(name,"<li><a href=\"",PolyURL(f,3),"\">",PolyTypeDec(PolytopeType(f[2])),"</a> ");
      AppendTo(name,"<br>\n");
    od;
    AppendTo(name,"</ol><br><br>\n");
  fi;
  AppendTo(name,"<br>\n<b>Other Groups of <a href=\"../index.html\">Order ",grp[1],"</a> : </b><br><ol>");
  for j in Filtered(gid,x -> x[1]=grp[1]) do
    AppendTo(name,"<li>");
    AppendTo(name,"<a href=\"../",j[2],"/index.html\">SmallGroup(",j[1],",",j[2],")</a>");
    num := Size(Filtered(poly,x -> x[1][1]=j[1] and x[1][2]=j[2] and x[1][4]=0));
    AppendTo(name," <b>",num,"</b> nondegenerate polytope");
    if not (num = 1) then AppendTo(name,"s"); fi;
    num := Size(Filtered(poly,x -> x[1][1]=j[1] and x[1][2]=j[2] and x[1][4]=1));
    AppendTo(name," and <b>",num,"</b> degenerate polytope");
    if not (num = 1) then AppendTo(name,"s"); fi;
    if (grp[2] = j[2]) then AppendTo(name," (this group)"); fi;
    AppendTo(name,".\n");
  od;
  AppendTo(name,"</ol>\n");
  AppendTo(name,"</body></html>\n");
end;

SummariseGroupSize := function(name,sz)
  local pol,j,rl,r,gid,num,pold,rld,numd,gidd;
  PrintTo(name,"<html><head><title>Groups of Size ");
  AppendTo(name, sz, " - Atlas of Small Regular Polytopes</title></head>\n");
  AppendTo(name, "<body bgcolor=#aaffcc>\n");
  AppendTo(name, "<h1>Groups of Size ",sz,"</h1>\n");
  AppendTo(name, "This page is part of the <a href=\"../index.html\">");
  AppendTo(name, "Atlas of Small Regular Polytopes</a><br>");
  pol := Filtered(poly,x -> x[1][1]=sz and x[1][4]=0);
  rl := RankList(List(pol,x -> x[2]));
  pold := Filtered(poly,x -> x[1][1]=sz and x[1][4]=1);
  rld := RankList(List(pold,x -> x[2]));
  gid := Set(pol,x -> x[1]);
  gidd := Set(pold,x -> x[1]);
  AppendTo(name, "<b>",Size(Set(Union(gid,gidd), x -> x[2]))," groups yielding <b>",Sum(rl),"</b> nondegenerate and ");
  AppendTo(name, "<b>",Sum(rld),"</b> degenerate polytopes.</b><br><br>\n");
  for j in [1..Maximum(Length(rl),Length(rld))] do
    if (j > Length(rl)) then rl[j] := 0; fi;
    if (j > Length(rld)) then rld[j] := 0; fi;
    if rl[j]+rld[j] > 0 then
      AppendTo(name, "<b>Rank ",j," Polytopes : </b><b>",rl[j],"</b> nondegenerate and <b>",rld[j],"</b> degenerate.<br>\n");
    fi;
  od;
  AppendTo(name, "<br>\n");
  AppendTo(name, "<b>Groups : </b><ol>\n");
  for j in Set(Union(gid,gidd), x -> x[2]) do
    AppendTo(name,"<li>");
    AppendTo(name,"<a href=\"",j,"/index.html\">SmallGroup(",sz,",",j,")</a>");
    num := Size(Filtered(poly,x -> x[1][1]=sz and x[1][2]=j and x[1][4]=0));
    numd := Size(Filtered(poly,x -> x[1][1]=sz and x[1][2]=j and x[1][4]=1));
    AppendTo(name," <b>",num,"</b> nondegenerate polytope");
    if not (num = 1) then AppendTo(name,"s"); fi;
    AppendTo(name," and \n");
    AppendTo(name," <b>",numd,"</b> degenerate polytope");
    if not (numd = 1) then AppendTo(name,"s"); fi;
    AppendTo(name,".\n");
  od;
  AppendTo(name,"</ol>\n");
  AppendTo(name,"</body></html>\n");
end;

SummariseRank := function(name,pl,pld,r,mxr,pt,ptd)
  local tp,num;
  PrintTo(name,"<html><head><title>Polytopes of Rank ",r);
  AppendTo(name, " - Atlas of Small Regular Polytopes</title></head>\n");
  AppendTo(name, "<body bgcolor=#aaffcc>\n");
  AppendTo(name, "<h1>Polytopes of Rank ",r,"</h1>\n");
  AppendTo(name, "This page is part of the <a href=\"../index.html\">");
  AppendTo(name, "Atlas of Small Regular Polytopes</a><br>");
  AppendTo(name, "(See : ");
  if (r > 1) then
    AppendTo(name,"<a href=\"../r",r-1,"/index.html\">Lower Ranked</a> ");
  fi;
  if (r > 1 and r < mxr) then 
    AppendTo(name,"| ");
  fi;
  if (r < mxr) then
    AppendTo(name, "<a href=\"../r",r+1,"/index.html\">Higher Ranked</a> ");
  fi;
  AppendTo(name,"Polytopes)<br><br>\n");
  AppendTo(name,"<b>All Polytopes :</b> ",Size(pl)+Size(pld)," polytopes in all, with ",Size(pt)+Size(ptd)," different Schlafli types<br><br>");
  AppendTo(name,"<b>Non-degenerate Polytopes :</b> ",Size(pl)," polytopes, with ",Size(pt)," different Schlafli types<br>");
  AppendTo(name,"<ol>\n");
  for tp in pt do
     AppendTo(name,"  <li> ");
     AppendTo(name,"<a href=\"",ListDec("./sch",".",".html",tp),"\">",PolyTypeDec(tp),"</a> ");
     num := Size(Filtered(pl,x -> PolytopeType(x[2])=tp));
     AppendTo(name,"(",num," polytope");
     if not (num = 1) then
       AppendTo(name,"s");
     fi;
     AppendTo(name,")\n");
  od;
  AppendTo(name,"</ol><br>");
  AppendTo(name,"<b>Degenerate Polytopes :</b> ",Size(pld)," polytopes, with ",Size(ptd)," different Schlafli types<br>");
  AppendTo(name,"<ol>\n");
  for tp in ptd do
     AppendTo(name,"  <li> ");
     AppendTo(name,"<a href=\"",ListDec("./sch",".",".html",tp),"\">",PolyTypeDec(tp),"</a> ");
     num := Size(Filtered(pld,x -> PolytopeType(x[2])=tp));
     AppendTo(name,"(",num," polytope");
     if not (num = 1) then
       AppendTo(name,"s");
     fi;
     AppendTo(name,")\n");
  od;
  AppendTo(name,"</ol><br><br>");
  AppendTo(name,"</body></html>\n");
end;
  

SummariseSchlafliSymbol := function(name,pl,sch)
  local pol,j,rl,r,gid,num;
  PrintTo(name,"<html><head><title>Polytopes of Type ",PolyTypeDec(sch));
  AppendTo(name, "</title></head>\n");
  AppendTo(name, "<body bgcolor=#aaffcc>\n");
  AppendTo(name, "<h1>Polytopes of Type ",PolyTypeDec(sch),"</h1>\n");
  AppendTo(name, "This page is part of the <a href=\"../index.html\">");
  AppendTo(name, "Atlas of Small Regular Polytopes</a><br>");
  AppendTo(name, "(See <a href=\"index.html\">Other Polytopes</a> of Rank ",Size(sch)+1,")<br><br>\n");
  if Size(pl) = 1 then 
    AppendTo(name, "There is <b>",Size(pl),"</b> polytope of this type in this atlas. ");
    AppendTo(name, "It is :<br>\n");
  else 
    AppendTo(name, "There are <b>",Size(pl),"</b> polytopes of this type in this atlas. ");
    AppendTo(name, "They are :<br>\n");
  fi;
  AppendTo(name,"<ol>\n");
  for pol in pl do
     AppendTo(name,"  <li> ");
     AppendTo(name,"<a href=\"",PolyURL(pol,2),"\">Size ",pol[1][1],"</a> ");
     AppendTo(name,"(SmallGroup(",pol[1][1],",",pol[1][2],")) ");
     if IsUniv(pol[1]) then
       AppendTo(name,"(Universal) ");
     fi;
     AppendTo(name,"\n");
  od;
  AppendTo(name,"</ol><br><br>");
  AppendTo(name,"</body></html>\n");
end;


Exec("mkdir atlas");
for i in gsz do
  path := Concatenation("atlas/",DigitsNumber(i,10));
  Exec(Concatenation("mkdir ",path));
Print("writing html for polytopes (groups) of size ",i,"\n");
  SummariseGroupSize(Concatenation(path,"/index.html"),i);
  for j in Filtered(gid,x -> x[1]=i) do
    path2 := Concatenation(path,"/",DigitsNumber(j[2],10));
    Exec(Concatenation("mkdir ",path2));
    path2 := Concatenation(path2,"/");
    pptmp := Filtered(poly,x -> x[1][1] = j[1] and x[1][2]=j[2]);
    pp := Filtered(pptmp,x -> x[1][4]=0);
    for k in pp do
      SummarisePoly(Concatenation(path2,DigitsNumber(k[1][3],10),".html"),k,j);
    od;   
    pp := Filtered(pptmp,x -> x[1][4]=1);
    for k in pp do
      SummarisePoly(Concatenation(path2,"d",DigitsNumber(k[1][3],10),".html"),k,j);
    od;   
    SummariseGroup(Concatenation(path2,"index.html"),[j[1],j[2]]);
  od;
od;



rl := RankList(List(app,x -> x[2]));
for r in [1..Length(rl)] do
Print("writing html for summaries of rank ",r," polytope types\n");
  path := Concatenation("atlas/r",DigitsNumber(r,10));
  fp := Filtered(poly,x -> Size(x[2])=r and x[1][4]=0);
  fpd := Filtered(poly,x -> Size(x[2])=r and x[1][4]=1);
  Exec(Concatenation("mkdir ",path));
  pt := Set(fp,x -> PolytopeType(x[2]));
  ptd := Set(fpd,x -> PolytopeType(x[2]));
  SummariseRank(Concatenation(path,"/index.html"),fp,fpd,r,Length(rl),pt,ptd);
  for j in pt do
    path2 := Concatenation(path,ListDec("/sch",".",".html",j));
    SummariseSchlafliSymbol(path2,Filtered(poly,x -> PolytopeType(x[2])=j),j);
  od;
  for j in ptd do
    path2 := Concatenation(path,ListDec("/sch",".",".html",j));
    SummariseSchlafliSymbol(path2,Filtered(poly,x -> PolytopeType(x[2])=j),j);
  od;
od;

name := "atlas/index.html";
PrintTo(name,"<html><head><title>Atlas of Small Regular Polytopes</title></head>");
AppendTo(name, "<body bgcolor=#aaffcc>\n");
AppendTo(name, "<h1>The Atlas of Small Regular Polytopes</h1>\n");
AppendTo(name, "This atlas contains information about all regular polytopes with <i>n</i>\n");
AppendTo(name, "flags\n");
AppendTo(name, "where <i>n</i> is at most 2000, and not equal to 512, 1024 or 1536\n");
AppendTo(name, "Work on polytopes of size 512 is in progress,\n");
AppendTo(name, "and it is envisaged\n");
AppendTo(name, "that polytopes of this size will eventually be incorporated.\n");
AppendTo(name, "<p>\n");
AppendTo(name, "Feel free to browse!\n");
AppendTo(name, "<p>\n");
AppendTo(name, "<b>Polytopes of :</b>\n");
AppendTo(name, "<ul>\n");
for r in [1..Length(rl)] do
  AppendTo(name, "<li><b><a href=\"r",r,"\">Rank ",r,"</a></b> - ");
  AppendTo(name, "<b>", Size(Filtered(app,x -> Size(x[2])=r and x[1][4]=0)), "</b> nondegenerate and ");
  AppendTo(name, "<b>", Size(Filtered(app,x -> Size(x[2])=r and x[1][4]=1)), "</b> degenerate polytopes\n");
od;
AppendTo(name, "</ul>\n");
AppendTo(name, "<b>Automorphism Groups of Size :</b><br>\n");
for div in Reversed([1..8]) do
  AppendTo(name, "<b>2<sup>",div,"</sup>k : ");
  for s in Filtered(gsz, x -> IsInt(x/2^div) and not IsInt(x/2^div/2)) do
    if (s > 2^div) then
      AppendTo(name, "|");
    fi;
    AppendTo(name, " <a href=\"",s,"\">",s,"</a> ");
  od;
  AppendTo(name, "<br><br>\n");
od;
AppendTo(name, "<p>That's all, folks!\n");
AppendTo(name, "</body></html>\n\n");
