polynames := [];
citations := [];

addName := function(sz,id,pid,degen,name)
  Append(polynames,[[[sz,id,pid,degen],name]]);
end;

getNames := function(sz,id,pid,degen)
  return List(Filtered(polynames,x -> x[1][1]=sz and x[1][2]=id and x[1][3]=pid and x[1][4]=degen),y -> y[2]);
end;

addCitation := function(sz,id,pid,degen,name)
  Append(citations,[[[sz,id,pid,degen],name]]);
end;

getCitations := function(sz,id,pid,degen)
  return List(Filtered(citations,x -> x[1][1]=sz and x[1][2]=id and x[1][3]=pid and x[1][4]=degen),y -> y[2]);
end;

addName(2,1,1,0,"line segment");
addName(2,1,1,0,"1-simplex");
addName(6,1,1,0,"triangle");
addName(6,1,1,0,"2-simplex");
addName(8,3,1,0,"square");
addName(8,3,1,0,"quadrangle");
addName(8,3,1,0,"2-cube");
addName(10,1,1,0,"pentagon");
addName(12,4,1,0,"hexagon");
addName(14,1,1,0,"heptagon");
addName(16,7,1,0,"octagon");
addName(18,1,1,0,"nonagon");
addName(20,4,1,0,"decagon");
addName(22,1,1,0,"endecagon");
addName(24,6,1,0,"dodecagon");
addName(24,12,1,0,"tetrahedron");
addName(24,12,1,0,"3-simplex");
addName(24,12,3,0,"hemicube");
addName(24,12,2,0,"hemioctahedron");
addName(48,48,3,0,"cube");
addName(48,48,1,0,"octahedron");
addName(60,5,1,0,"hemiicosahedron");
addName(60,5,2,0,"hemidodecahedron");
addName(120,35,1,0,"icosahedron");
addName(120,35,4,0,"dodecahedron");
Read("dih.gap");
addName(120,34,1,0,"4-simplex");
addName(720,763,1,0,"5-simplex");
addName(192,955,3,0,"hemi-4-cube");
addName(192,955,1,0,"hemi-4-cross-polytope");
addName(384,5602,4,0,"4-cube");
addName(384,5602,1,0,"4-cross-polytope");
addName(1920,240996,4,0,"hemi-5-cube");
addName(1920,240996,1,0,"hemi-5-cross-polytope");
addName(576,8654,1,0,"hemi-24-cell");
addName(1152,157478,1,0,"24-cell");
addCitation(120,34,1,0,"Schlfli, L.; Theorie Der Vielfachen Kontinuitt, Denkschriften Der Schweizerischen Naturforschenden Gesellschaft, 38, pp1237 (1901)");
addCitation(720,763,1,0,"Schlfli, L.; Theorie Der Vielfachen Kontinuitt, Denkschriften Der Schweizerischen Naturforschenden Gesellschaft, 38, pp1237 (1901)");
addCitation(384,5602,1,0,"Schlfli, L.; Theorie Der Vielfachen Kontinuitt, Denkschriften Der Schweizerischen Naturforschenden Gesellschaft, 38, pp1237 (1901)");
addCitation(384,5602,4,0,"Schlfli, L.; Theorie Der Vielfachen Kontinuitt, Denkschriften Der Schweizerischen Naturforschenden Gesellschaft, 38, pp1237 (1901)");
addCitation(1152,157478,1,0,"Schlfli, L.; Theorie Der Vielfachen Kontinuitt, Denkschriften Der Schweizerischen Naturforschenden Gesellschaft, 38, pp1237 (1901)");
#{4,4,4}
addName(128,1135,1,0,"<sub>2</sub>T<sup>4</sup><sub>(2,0)(2,0)</sub>");
addName(256,16888,1,0,"<sub>2</sub>T<sup>4</sup><sub>(2,0)(2,2)</sub>");
addName(256,16888,2,0,"<sub>2</sub>T<sup>4</sup><sub>(2,2)(2,0)</sub>");
#addName(512,???,?,0,"<sub>2</sub>T<sup>4</sup><sub>(2,0)(4,0)</sub>");
#addName(512,???,?,0,"<sub>2</sub>T<sup>4</sup><sub>(4,0)(2,0)</sub>");
addName(576,8399,1,0,"<sub>2</sub>T<sup>4</sup><sub>(3,3)(2,0)</sub>");
addName(576,8399,2,0,"<sub>2</sub>T<sup>4</sup><sub>(2,0)(3,3)</sub>");
#addName(1024,???,?,0,"<sub>2</sub>T<sup>4</sup><sub>(2,0)(4,4)</sub>");
#addName(1024,???,?,0,"<sub>2</sub>T<sup>4</sup><sub>(4,4)(2,0)</sub>");
#addName(1024,???,?,0,"<sub>2</sub>T<sup>4</sup><sub>(2,2)(2,2)</sub>");  # Thm 10C5
addName(1152,43028,1,0,"<sub>2</sub>T<sup>4</sup><sub>(2,0)(6,0)</sub>");
addName(1152,43028,2,0,"<sub>2</sub>T<sup>4</sup><sub>(6,0)(2,0)</sub>");
addName(1440,5842,16,0,"<sub>2</sub>T<sup>4</sup><sub>(3,0)(3,0)</sub>");
addName(1600,10031,1,0,"<sub>2</sub>T<sup>4</sup><sub>(2,0)(5,5)</sub>");
addName(1600,10031,2,0,"<sub>2</sub>T<sup>4</sup><sub>(5,5)(2,0)</sub>");
addCitation(128,1135,1,0,"Theorem 10C12, McMullen P., Schulte, E.; Abstract Regular Polytopes (Cambridge University Press, 2002)");
addCitation(256,16888,1,0,"Theorem 10C2, McMullen P., Schulte, E.; Abstract Regular Polytopes (Cambridge University Press, 2002)");
addCitation(256,16888,2,0,"Theorem 10C2, McMullen P., Schulte, E.; Abstract Regular Polytopes (Cambridge University Press, 2002)");
addCitation(576,8399,1,0,"Theorem 10C2, McMullen P., Schulte, E.; Abstract Regular Polytopes (Cambridge University Press, 2002)");
addCitation(576,8399,2,0,"Theorem 10C2, McMullen P., Schulte, E.; Abstract Regular Polytopes (Cambridge University Press, 2002)");
addCitation(1152,43028,1,0,"Theorem 10C12, McMullen P., Schulte, E.; Abstract Regular Polytopes (Cambridge University Press, 2002)");
addCitation(1152,43028,2,0,"Theorem 10C12, McMullen P., Schulte, E.; Abstract Regular Polytopes (Cambridge University Press, 2002)");
addCitation(1440,5842,16,0,"Theorem 10C12, McMullen P., Schulte, E.; Abstract Regular Polytopes (Cambridge University Press, 2002)");
addCitation(1600,10031,1,0,"Theorem 10C2, McMullen P., Schulte, E.; Abstract Regular Polytopes (Cambridge University Press, 2002)");
addCitation(1600,10031,2,0,"Theorem 10C2, McMullen P., Schulte, E.; Abstract Regular Polytopes (Cambridge University Press, 2002)");
#{4,4,3}
addName(192,1472,3,0,"<sub>1</sub>T<sup>4</sup><sub>(2,0)</sub>");
addName(192,1472,1,0,"Dual of <sub>1</sub>T<sup>4</sup><sub>(2,0)</sub>");
#addName(768,?,?,0,"<sub>1</sub>T<sup>4</sup><sub>(2,2)</sub>");
#addName(768,?,?,0,"Dual of <sub>1</sub>T<sup>4</sup><sub>(2,2)</sub>");
addName(1440,5842,11,0,"<sub>1</sub>T<sup>4</sup><sub>(3,0)</sub>");
addName(1440,5842,4,0,"Dual of <sub>1</sub>T<sup>4</sup><sub>(3,0)</sub>");
addCitation(192,1472,1,0,"Theorem 10B3, McMullen P., Schulte, E.; Abstract Regular Polytopes (Cambridge University Press, 2002)");
addCitation(192,1472,3,0,"Theorem 10B3, McMullen P., Schulte, E.; Abstract Regular Polytopes (Cambridge University Press, 2002)");
addCitation(1440,5842,11,0,"Theorem 10B3, McMullen P., Schulte, E.; Abstract Regular Polytopes (Cambridge University Press, 2002)");
addCitation(1440,5842,4,0,"Theorem 10B3, McMullen P., Schulte, E.; Abstract Regular Polytopes (Cambridge University Press, 2002)");
#{6,3,3}
addName(240,189,11,0,"<sub>3</sub>T<sup>4</sup><sub>(2,0)</sub>");
addName(240,189,1,0,"Dual of <sub>3</sub>T<sup>4</sup><sub>(2,0)</sub>");
addName(1296,3490,11,0,"<sub>3</sub>T<sup>4</sup><sub>(3,0)</sub>");
addName(1296,3490,1,0,"Dual of <sub>3</sub>T<sup>4</sup><sub>(3,0)</sub>");
addCitation(240,189,11,0,"Theorem 11B5, McMullen P., Schulte, E.; Abstract Regular Polytopes (Cambridge University Press, 2002)");
addCitation(240,189,1,0,"Theorem 11B5, McMullen P., Schulte, E.; Abstract Regular Polytopes (Cambridge University Press, 2002)");
addCitation(1296,3490,11,0,"Theorem 11B5, McMullen P., Schulte, E.; Abstract Regular Polytopes (Cambridge University Press, 2002)");
addCitation(1296,3490,1,0,"Theorem 11B5, McMullen P., Schulte, E.; Abstract Regular Polytopes (Cambridge University Press, 2002)");
#{6,3,4}
addName(288,1028,7,0,"<sub>4</sub>T<sup>4</sup><sub>(1,1)</sub>");
addName(288,1028,3,0,"Dual of <sub>4</sub>T<sup>4</sup><sub>(1,1)</sub>");
#addName(768,??,?,0,"<sub>4</sub>T<sup>4</sup><sub>(2,0)</sub>");
#addName(768,??,?,0,"Dual of <sub>4</sub>T<sup>4</sup><sub>(2,0)</sub>");
addCitation(288,1028,7,0,"Theorem 11C7,11C8, McMullen P., Schulte, E.; Abstract Regular Polytopes (Cambridge University Press, 2002)");
addCitation(288,1028,3,0,"Theorem 11C7,11C8, McMullen P., Schulte, E.; Abstract Regular Polytopes (Cambridge University Press, 2002)");
#{6,3,5}  -- none! Smallest has order 28800
#{6,3,6}
addName(216,162,2,0,"<sub>6</sub>T<sup>4</sup><sub>(1,1)(1,1)</sub>");
addName(480,1186,4,0,"<sub>6</sub>T<sup>4</sup><sub>(2,0)(2,0)</sub>");
addName(648,555,5,0,"<sub>6</sub>T<sup>4</sup><sub>(1,1)(3,0)</sub>");
addName(648,555,6,0,"<sub>6</sub>T<sup>4</sup><sub>(3,0)(1,1)</sub>");
addName(864,4673,11,0,"<sub>6</sub>T<sup>4</sup><sub>(1,1)(2,2)</sub>");
addName(864,4673,12,0,"<sub>6</sub>T<sup>4</sup><sub>(2,2)(1,1)</sub>");
addName(1944,2346,3,0,"<sub>6</sub>T<sup>4</sup><sub>(1,1)(3,3)</sub>");
addName(1944,2346,4,0,"<sub>6</sub>T<sup>4</sup><sub>(1,1)(3,3)</sub>");
addCitation(216,162,2,0,"Theorem 11C7,11C8, McMullen P., Schulte, E.; Abstract Regular Polytopes (Cambridge University Press, 2002)");
addCitation(480,1186,4,0,"Theorem 11D5, McMullen P., Schulte, E.; Abstract Regular Polytopes (Cambridge University Press, 2002)");
addCitation(648,555,5,0,"Theorem 11C7,11C8, McMullen P., Schulte, E.; Abstract Regular Polytopes (Cambridge University Press, 2002)");
addCitation(648,555,6,0,"Theorem 11C7,11C8, McMullen P., Schulte, E.; Abstract Regular Polytopes (Cambridge University Press, 2002)");
addCitation(864,4673,11,0,"Theorem 11C7,11C8, McMullen P., Schulte, E.; Abstract Regular Polytopes (Cambridge University Press, 2002)");
addCitation(864,4673,12,0,"Theorem 11C7,11C8, McMullen P., Schulte, E.; Abstract Regular Polytopes (Cambridge University Press, 2002)");
addCitation(1944,2346,3,0,"Theorem 11C7,11C8, McMullen P., Schulte, E.; Abstract Regular Polytopes (Cambridge University Press, 2002)");
addCitation(1944,2346,4,0,"Theorem 11C7,11C8, McMullen P., Schulte, E.; Abstract Regular Polytopes (Cambridge University Press, 2002)");
#{3,6,3}
addName(108,17,2,0,"<sub>7</sub>T<sup>4</sup><sub>(1,1)(1,1)</sub>");
addName(240,189,2,0,"<sub>7</sub>T<sup>4</sup><sub>(2,0)(2,0)</sub>");
addName(324,39,1,0,"<sub>7</sub>T<sup>4</sup><sub>(1,1)(3,0)</sub>");
addName(324,39,2,0,"<sub>7</sub>T<sup>4</sup><sub>(3,0)(1,1)</sub>");
addName(720,767,3,0,"<sub>7</sub>T<sup>4</sup><sub>(2,0)(2,2)</sub>");
addName(720,767,4,0,"<sub>7</sub>T<sup>4</sup><sub>(2,2)(2,0)</sub>");
addCitation(720,767,3,0,"Theorem 11E5,11E10, McMullen P., Schulte, E.; Abstract Regular Polytopes (Cambridge University Press, 2002)");
addCitation(720,767,4,0,"Theorem 11E5,11E10, McMullen P., Schulte, E.; Abstract Regular Polytopes (Cambridge University Press, 2002)");
addCitation(324,39,1,0,"Theorem 11E7, McMullen P., Schulte, E.; Abstract Regular Polytopes (Cambridge University Press, 2002)");
addCitation(324,39,2,0,"Theorem 11E7, McMullen P., Schulte, E.; Abstract Regular Polytopes (Cambridge University Press, 2002)");
addCitation(240,189,2,0,"Theorem 11E10, McMullen P., Schulte, E.; Abstract Regular Polytopes (Cambridge University Press, 2002)");
addCitation(108,17,2,0,"Notes following Theorem 11E7, McMullen P., Schulte, E.; Abstract Regular Polytopes (Cambridge University Press, 2002)");
#{3,5,3}
addName(660,13,1,0,"11-cell");
addCitation(660,13,1,0,"Coxeter, H. S. M.; A Symmetrical Arrangement of Eleven hemi-Icosahedra, Annals of Discrete Mathematics 20 pp103114 (1984)");
addCitation(660,13,1,0,"Grnbaum, B.; Regularity of Graphs, Complexes and Designs, in Problmes Combinatoires et Thorie des Graphes, Colloquium Internationale CNRS, Orsay, 260 pp191197 (1977)");
#{4,3,5}
addName(1920,240995,2,0,"hemi-2<sup>{3,5}/2</sup>");
addCitation(1920,240995,2,0,"Hartley, M. I.; Quotients of Some Finite Universal Locally Projective Polytopes, Discrete and Computational Geometry 29 pp435-443 (2003)");
#{4,3,4}
addName(384,20163,1,0,"{4,3,4}<sub>(2,0,0)</sub>");
#addName(768,???,?,0,"{4,3,4}<sub>(2,2,0)</sub>");
#addName(1536,???,?,0,"{4,3,4}<sub>(2,2,2)</sub>");
addName(1296,3490,5,0,"{4,3,4}<sub>(3,0,0)</sub>");
#{4,4}
addName(32,27,1,0,"{4,4}<sub>(2,0)</sub>");
addName(64,138,1,0,"{4,4}<sub>(2,2)</sub>");
addName(72,40,1,0,"{4,4}<sub>(3,0)</sub>");
addName(128,928,1,0,"{4,4}<sub>(4,0)</sub>");
addName(144,186,1,0,"{4,4}<sub>(3,3)</sub>");
addName(200,43,1,0,"{4,4}<sub>(5,0)</sub>");
addName(256,6661,1,0,"{4,4}<sub>(4,4)</sub>");
addName(288,889,1,0,"{4,4}<sub>(6,0)</sub>");
addName(392,37,1,0,"{4,4}<sub>(7,0)</sub>");
addName(400,211,1,0,"{4,4}<sub>(5,5)</sub>");
# addName(512,???,?,?, "{4,4}<sub>(8,0)</sub>");
addName(576,5296,1,0,"{4,4}<sub>(6,6)</sub>");
addName(648,252,1,0,"{4,4}<sub>(9,0)</sub>");
addName(784,165,1,0,"{4,4}<sub>(7,7)</sub>");
addName(800,1058,1,0,"{4,4}<sub>(10,0)</sub>");
addName(968,36,1,0,"{4,4}<sub>(11,0)</sub>");
# addName(1024,???,?,?, "{4,4}<sub>(8,8)</sub>");
addName(1152,32554,1,0,"{4,4}<sub>(12,0)</sub>");
addName(1296,1813,1,0,"{4,4}<sub>(9,9)</sub>");
addName(1352,43,1,0,"{4,4}<sub>(13,0)</sub>");
addName(1568,821,1,0,"{4,4}<sub>(14,0)</sub>");
addName(1600,6624,1,0,"{4,4}<sub>(10,10)</sub>");
addName(1800,664,1,0,"{4,4}<sub>(15,0)</sub>");
addName(1936,161,1,0,"{4,4}<sub>(11,11)</sub>");
# {6,3}
addName(36,10,2,0,"{6,3}<sub>(1,1)</sub>");
addName(48,48,6,0,"{6,3}<sub>(2,0)</sub>");
addName(108,17,3,0,"{6,3}<sub>(3,0)</sub>");
addName(144,183,4,0,"{6,3}<sub>(2,2)</sub>");
addName(192,956,3,0,"{6,3}<sub>(4,0)</sub>");
addName(300,25,3,0,"{6,3}<sub>(5,0)</sub>");
addName(324,41,3,0,"{6,3}<sub>(3,3)</sub>");
addName(432,523,7,0,"{6,3}<sub>(6,0)</sub>");
addName(576,5053,3,0,"{6,3}<sub>(4,4)</sub>");
addName(588,35,3,0,"{6,3}<sub>(7,0)</sub>");
# addName(768,???,?,0,"{6,3}<sub>(8,0)</sub>");
addName(900,95,3,0,"{6,3}<sub>(5,5)</sub>");
addName(972,115,3,0,"{6,3}<sub>(9,0)</sub>");
addName(1200,985,5,0,"{6,3}<sub>(10,0)</sub>");
addName(1296,1784,5,0,"{6,3}<sub>(6,6)</sub>");
addName(1452,22,3,0,"{6,3}<sub>(11,0)</sub>");
addName(1728,12317,3,0,"{6,3}<sub>(12,0)</sub>");
addName(1764,146,3,0,"{6,3}<sub>(7,7)</sub>");
# {3,6}
addName(36,10,1,0,"{3,6}<sub>(1,1)</sub>");
addName(48,48,2,0,"{3,6}<sub>(2,0)</sub>");
addName(108,17,1,0,"{3,6}<sub>(3,0)</sub>");
addName(144,183,1,0,"{3,6}<sub>(2,2)</sub>");
addName(192,956,1,0,"{3,6}<sub>(4,0)</sub>");
addName(300,25,1,0,"{3,6}<sub>(5,0)</sub>");
addName(324,41,1,0,"{3,6}<sub>(3,3)</sub>");
addName(432,523,1,0,"{3,6}<sub>(6,0)</sub>");
addName(576,5053,1,0,"{3,6}<sub>(4,4)</sub>");
addName(588,35,1,0,"{3,6}<sub>(7,0)</sub>");
addName(900,95,1,0,"{3,6}<sub>(5,5)</sub>");
addName(972,115,1,0,"{3,6}<sub>(9,0)</sub>");
addName(1200,985,1,0,"{3,6}<sub>(10,0)</sub>");
addName(1296,1784,1,0,"{3,6}<sub>(6,6)</sub>");
addName(1452,22,1,0,"{3,6}<sub>(11,0)</sub>");
addName(1728,12317,1,0,"{3,6}<sub>(12,0)</sub>");
addName(1764,146,1,0,"{3,6}<sub>(7,7)</sub>");
